<?php
$targetDir = "audio_recordings/"; // Ensure this directory exists and is writable

// Extract participant ID from the FormData sent via POST
$participantId = isset($_POST['pid']) ? preg_replace("/[^a-zA-Z0-9]+/", "", $_POST['pid']) : "unknown";

$fileExt = ".webm"; // Expected file extension for the audio

// Include the participant ID and task code in the file name
$taskCode = "dualload"; // Adjust the task code as needed
$fileName = $participantId . "_" . $taskCode . $fileExt;
$targetFile = $targetDir . basename($fileName);

// Ensure the audio recordings directory exists
if (!file_exists($targetDir)) {
    mkdir($targetDir, 0777, true);
}

// Move the uploaded audio file to the target directory
if (move_uploaded_file($_FILES['audio']['tmp_name'], $targetFile)) {
    echo "The file $fileName has been uploaded.";

    // Specify the output filename, changing extension to .mp3
    $convertedFileName = str_replace($fileExt, ".mp3", $targetFile);

    // Construct the FFmpeg command for conversion
    $command = "ffmpeg -i \"$targetFile\" -acodec libmp3lame \"$convertedFileName\"";

    // Execute the FFmpeg command
    exec($command, $output, $returnCode);

    // Check if FFmpeg successfully converted the file
    if ($returnCode === 0) {
        echo "Conversion to MP3 successful.";
        // Optionally, delete the original .webm file to save space
        unlink($targetFile);
    } else {
        echo "Error during conversion.";
    }
} else {
    echo "Error uploading the file.";
}
?>
