<?php
$targetDir = "audio_recordings/"; // Directory to store audio recordings

// Check if the audio file and participant ID are provided
if (isset($_FILES['audio']) && isset($_POST['pid'])) {
    // Sanitize the participant ID to avoid unwanted characters
    $participantId = preg_replace("/[^a-zA-Z0-9]+/", "", $_POST['pid']);

    $fileExt = ".webm"; // Expected file extension for the audio file
    $taskCode = "InhibitVFT"; // Task code for the InhibitionVFT1 experiment

    // Construct the file name using the participant ID and task code
    $fileName = $participantId . "_" . $taskCode . $fileExt;
    $targetFile = $targetDir . basename($fileName);

    // Create the target directory if it doesn't exist, with more restrictive permissions
    if (!file_exists($targetDir)) {
        mkdir($targetDir, 0755, true);
    }

    // Attempt to move the uploaded audio file to the target directory
    if (move_uploaded_file($_FILES['audio']['tmp_name'], $targetFile)) {
        echo "The file $fileName has been successfully uploaded.";

        // Define the output filename for the converted MP3 file
        $convertedFileName = $targetDir . $participantId . "_" . $taskCode . ".mp3";

        // Construct the FFmpeg command to convert the WebM audio file to MP3
        $command = "ffmpeg -i \"$targetFile\" -acodec libmp3lame \"$convertedFileName\"";

        // Execute the FFmpeg command and check the result
        exec($command, $output, $returnCode);
        if ($returnCode === 0) {
            echo " Conversion to MP3 successful.";
            // Optionally delete the original WebM file to save space
            unlink($targetFile);
        } else {
            echo " Error during the conversion process.";
        }
    } else {
        echo "Error: Unable to upload the file. Please check file permissions and try again.";
    }
} else {
    echo "Error: No audio file or participant ID provided. Please ensure both are included in the request.";
}
?>
