<?php
$targetDir = "audio_recordings/"; // Ensure this directory exists and is writable

// Extract participant ID from POST data instead of GET
$participantId = isset($_POST['pid']) ? preg_replace("/[^a-zA-Z0-9]+/", "", $_POST['pid']) : "unknown";

$fileExt = ".webm"; // Default file extension

// Adjust the task code as needed
$taskCode = "tradvft"; // Task code for this particular task
$fileName = $participantId . "_" . $taskCode . $fileExt;
$targetFile = $targetDir . basename($fileName);

// Ensure the audio recordings directory exists
if (!file_exists($targetDir)) {
    mkdir($targetDir, 0755, true); // Using more restrictive permissions
}

// Move the uploaded file to the target directory
if (move_uploaded_file($_FILES['audio']['tmp_name'], $targetFile)) {
    echo "The file $fileName has been uploaded.";

    // Specify the output filename, changing extension to .mp3
    $convertedFileName = str_replace($fileExt, ".mp3", $targetFile);

    // Construct the FFmpeg command for conversion
    $command = "ffmpeg -i " . escapeshellarg($targetFile) . " -acodec libmp3lame " . escapeshellarg($convertedFileName);

    // Execute the command
    exec($command, $output, $returnCode);

    // Check if FFmpeg successfully converted the file
    if ($returnCode === 0) {
        echo "Conversion to MP3 successful.";
        // Optionally, delete the original file to save space
        unlink($targetFile);
    } else {
        echo "Error during conversion.";
    }
} else {
    echo "Error uploading the file.";
}
?>
